---
title: '::slotted()'
slug: 'Web/CSS/::slotted'
tags:
  - '::slotted'
  - CSS
  - Layout
  - Pseudo-element
  - Reference
  - Selector
  - Web
---
<div>{{ CSSRef }}</div>

<p>The <strong><code>::slotted()</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Pseudo-elements">pseudo-element</a> represents any element that has been placed into a slot inside an HTML template (see <a href="/en-US/docs/Web/Web_Components/Using_templates_and_slots">Using templates and slots</a> for more information).</p>

<p>This only works when used inside CSS placed within a <a href="/en-US/docs/Web/Web_Components/Using_shadow_DOM">shadow DOM</a>. Note also that this selector won't select a text node placed into a slot; it only targets actual elements.</p>

<pre class="brush: css no-line-numbers notranslate">/* Selects any element placed inside a slot */
::slotted(*) {
  font-weight: bold;
}

/* Selects any &lt;span&gt; placed inside a slot */
::slotted(span) {
  font-weight: bold;
}
</pre>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Highlighting_slotted_elements">Highlighting slotted elements</h3>

<p>The following snippets are taken from our <a href="https://github.com/mdn/web-components-examples/tree/master/slotted-pseudo-element">slotted-pseudo-element</a> demo (<a href="https://mdn.github.io/web-components-examples/slotted-pseudo-element/">see it live also</a>).</p>

<p>In this demo we use a simple template with three slots:</p>

<pre class="brush: html notranslate">&lt;template id="person-template"&gt;
  &lt;div&gt;
    &lt;h2&gt;Personal ID Card&lt;/h2&gt;
    &lt;slot name="person-name"&gt;NAME MISSING&lt;/slot&gt;
    &lt;ul&gt;
      &lt;li&gt;&lt;slot name="person-age"&gt;AGE MISSING&lt;/slot&gt;&lt;/li&gt;
      &lt;li&gt;&lt;slot name="person-occupation"&gt;OCCUPATION MISSING&lt;/slot&gt;&lt;/li&gt;
    &lt;/ul&gt;
  &lt;/div&gt;
&lt;/template&gt;</pre>

<p>A custom element — <code>&lt;person-details&gt;</code> — is defined like so:</p>

<pre class="brush: js notranslate">customElements.define('person-details',
  class extends HTMLElement {
    constructor() {
      super();
      let template = document.getElementById('person-template');
      let templateContent = template.content;

      const shadowRoot = this.attachShadow({mode: 'open'});

      let style = document.createElement('style');
      style.textContent = 'div { padding: 10px; border: 1px solid gray; width: 200px; margin: 10px; }' +
                           'h2 { margin: 0 0 10px; }' +
                           'ul { margin: 0; }' +
                           'p { margin: 10px 0; }' +
                           '::slotted(*) { color: gray; font-family: sans-serif; } ';

      shadowRoot.appendChild(style);
      shadowRoot.appendChild(templateContent.cloneNode(true));
  }
})</pre>

<p>You'll see that when filling the <code>style</code> element with content, we select all slotted elements (<code>::slotted(*)</code>) and give them a different font and color. This allows them to stand out better next to the slots that haven't been successfully filled.</p>

<p>The element looks like this when inserted into the page:</p>

<pre class="brush: html notranslate">&lt;person-details&gt;
  &lt;p slot="person-name"&gt;Dr. Shazaam&lt;/p&gt;
  &lt;span slot="person-age"&gt;Immortal&lt;/span&gt;
  &lt;span slot="person-occupation"&gt;Superhero&lt;/span&gt;
&lt;/person-details&gt;</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('CSS Scope', '#slotted-pseudo', '::slotted') }}</td>
   <td>{{ Spec2('CSS Scope') }}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.selectors.slotted")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Web_Components">Web components</a></li>
</ul>
